#!/usr/bin/env python

"""
This is based on SimpleHTTPServer, but correctly redirects for directories
that aren't requested with a trailing slash.

Tim Hatch, 2007
"""

import os

from SimpleHTTPServer import SimpleHTTPRequestHandler, test

class RedirectingSimpleHTTPRequestHandler(SimpleHTTPRequestHandler):
    def send_head(self):
        """
        Overridden for handling directories...
        """
        path = self.translate_path(self.path)
        if os.path.isdir(path) and not self.path.endswith("/"):
            self.send_response(301)
            self.send_header("Location", self.path+"/")
            return None
        else:
            return SimpleHTTPRequestHandler.send_head(self)

if __name__ == "__main__":
    os.chdir('out')
    test(HandlerClass=RedirectingSimpleHTTPRequestHandler)
